SuperStrict
Type TVektor
	Field X#
	Field Y#
EndType

Type TKreis
	Global Kreisliste:TList

	Field OV:TVektor ' Ortsvektor
	Field MV:Tvektor ' Bewegungsvektor
	Field Radius#
	Field Bewegbar%
	Field Link:Tkreis
	
	Function Erstelle:Tkreis(X#,Y#,Radius#,bewegbar%=1,linked%=0)
		If tkreis.kreisliste= Null Then
			tkreis.kreisliste = New TList
		EndIf
		
		Local Kreis:Tkreis = New tkreis
		
		Kreis.OV = New Tvektor
		Kreis.ov.x=x
		kreis.ov.y=y
		Kreis.MV = New Tvektor
		kreis.Radius = Radius
		kreis.bewegbar=bewegbar
		
		If linked =True Then
		'	DebugStop
			kreis.link = tkreis(tkreis.kreisliste.last())
		EndIf
		
		tkreis.kreisliste.addlast(kreis)
		

		
		Return Kreis
	EndFunction
	Function draw()
		For Local kreis:tkreis = EachIn tkreis.kreisliste
			DrawOval(kreis.ov.x-kreis.radius,kreis.ov.y-kreis.radius,2*kreis.radius,2*kreis.radius)
		Next
	EndFunction
	Function update()
		For Local kreis:tkreis = EachIn tkreis.kreisliste
			If kreis.bewegbar=True Then
				kreis.mv.y=kreis.mv.y/1.3+4
				kreis.mv.x=kreis.mv.x/1.3
				For Local colkreis:tkreis = EachIn tkreis.kreisliste
					If Not(colkreis = kreis) Then
						Local entfernung#=(kreis.ov.x-colkreis.ov.x)^2+(kreis.ov.y-colkreis.ov.y)^2
						'Abstoen
						If entfernung# < (kreis.radius+colkreis.radius)^2 Then
							If colkreis.ov.x < kreis.ov.x Then
								kreis.mv.x =kreis.mv.x-((kreis.ov.x-colkreis.ov.x)/Sqr(entfernung#))*4.0
							Else
								kreis.mv.x =kreis.mv.x+((kreis.ov.x-colkreis.ov.x)/Sqr(entfernung#))*4.0
							EndIf
							If colkreis.ov.y < kreis.ov.y Then
								kreis.mv.y =kreis.mv.y-((kreis.ov.y-colkreis.ov.y)/Sqr(entfernung#))*4.0
							Else
								kreis.mv.y =kreis.mv.y+((kreis.ov.y-colkreis.ov.y)/Sqr(entfernung#))*4.0

							EndIf							
							'kreis.mv.x = kreis.mv.x+(kreis.radius+colkreis.radius)/(kreis.ov.x-colkreis.ov.x)
							'kreis.mv.y = kreis.mv.y+(kreis.radius+colkreis.radius)/(kreis.ov.y-colkreis.ov.y)
						EndIf
						
						'Anziehen
						If colkreis=kreis.link Then
							'DebugStop
							If entfernung# > (kreis.radius+colkreis.radius)^2 Then
								If colkreis.ov.x < kreis.ov.x Then
									kreis.mv.x =kreis.mv.x-Sqr(entfernung#)/5.0
								Else
									kreis.mv.x =kreis.mv.x+Sqr(entfernung#)/5.0
								EndIf
								If colkreis.ov.y < kreis.ov.y Then
									kreis.mv.y =kreis.mv.y-Sqr(entfernung#)/5.0
								Else
									kreis.mv.y =kreis.mv.y+Sqr(entfernung#)/5.0
								EndIf
							EndIf
						EndIf
					EndIf
				Next
				kreis.ov.x=kreis.ov.x+kreis.mv.x/25.0
				kreis.ov.y=kreis.ov.y+kreis.mv.y/25.0
			EndIf
		Next
	EndFunction
	
	Function move(x#,y#)
		For Local kreis:tkreis = EachIn tkreis.kreisliste
			If kreis.bewegbar=False Then
				kreis.ov.x=kreis.ov.x+x
				kreis.ov.y=kreis.ov.y+y
			EndIf
		Next
	EndFunction
EndType


Function Create_Elephant()
	Tkreis.erstelle(640/2,480-75,75,0) ' Bauch
	Tkreis.erstelle(640/2+25,480-190,40,0) ' Kopf
	For Local i%=1 To 5 ' Rssel
		Tkreis.erstelle(640/2-i*20,480-190-i*20,20/i,1,1)
	Next
EndFunction

SetGraphicsDriver(GLMax2DDriver())
Graphics(640,480,0)
create_elephant
Repeat
	If KeyDown(key_left) Then tkreis.move(-1,0)
	If KeyDown(key_right) Then tkreis.move(1,0)
	If KeyDown(key_up) Then tkreis.move(0,-1)
	If KeyDown(key_down) Then tkreis.move(0,1)


	Tkreis.update()
	
	Tkreis.draw()
	Flip
	Cls
Until KeyHit(Key_escape)